----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    23:16:12 04/23/2008 
-- Design Name: 
-- Module Name:    Top_module - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity Top_module is
	PORT (
		clkin : in  STD_LOGIC;
		ares : in  STD_LOGIC;
		btn : in  STD_LOGIC;
		btnsel : in  STD_LOGIC;
		reset_s : out  STD_LOGIC;
		start_s : out  STD_LOGIC;
		catode1 : out  STD_LOGIC;
		catode2 : out  STD_LOGIC;
		segment : out std_logic_vector(7 downto 0));
end Top_module;

architecture Behavioral of Top_module is

COMPONENT BCDcount1
	PORT(
		clk : IN std_logic;
		ar : IN std_logic;
		ce : IN std_logic;          
		q : OUT std_logic_vector(3 downto 0);
		carry : OUT std_logic
		);
	END COMPONENT;

COMPONENT BCDcount2
	PORT(
		clk : IN std_logic;
		ar : IN std_logic;
		ce : IN std_logic;          
		q : OUT std_logic_vector(3 downto 0);
		carry : OUT std_logic
		);
	END COMPONENT;

COMPONENT Stav_aut
	PORT(
		bt : IN std_logic;
		clk : IN std_logic;
		areset : IN std_logic;          
		start_out : OUT std_logic;
		stop_out : OUT std_logic;
		reset_out : OUT std_logic
		);
	END COMPONENT;

signal carry : std_logic_vector(2 downto 0);
signal cein : std_logic_vector(3 downto 1);
signal cestart : std_logic;
signal sr : std_logic;
signal div : std_logic_vector(3 downto 0);
signal clk : std_logic;
signal q : std_logic_vector(15 downto 0);
signal tlac : std_logic;
signal qout : STD_LOGIC_VECTOR (3 downto 0);
signal segment_n : STD_LOGIC_VECTOR (7 downto 0);

begin


	bcd0: 	BCDcount1 PORT MAP(clk => clk, ar => sr, ce => cestart, q => q(3 downto 0), carry => carry(0) );
	bcd1: 	BCDcount1 PORT MAP(clk => clk, ar => sr, ce => cein(1), q => q(7 downto 4), carry => carry(1) );
	bcd2: 	BCDcount1 PORT MAP(clk => clk, ar => sr, ce => cein(2), q => q(11 downto 8), carry => carry(2) );
	bcd3: 	BCDcount2 PORT MAP(clk => clk, ar => sr, ce => cein(3), q => q(15 downto 12) );
	s_a0: 	Stav_aut  PORT MAP(bt => btn, clk => clk, areset => ares, start_out => cestart, reset_out => sr);


	reset_s	<= sr;
	start_s	<= cestart;
	cein(1) 	<= carry(0);
	cein(2) 	<= carry(1) and carry(0);
	cein(3) 	<= carry(2) and carry(1) and carry(0);
	clk 		<= div(3);

--DELICKA HODIN----------------------------------------
process (clkin)
	variable qdiv : STD_LOGIC_VECTOR (3 downto 0);
	begin
	if rising_edge(clkin) then
		if qdiv = "1111" then qdiv := "0000";
			else qdiv := qdiv+1;
			end if;
		end if;
	div <= qdiv;
end process;
-------------------------------------------------------

--PREPINANI RADU---------------------------------------
process (btnsel)
	begin 
	if rising_edge(btnsel) then 
		tlac <= not tlac;
		end if;
end process;

process (tlac, clk, q)
	variable qmid : std_logic_vector (7 downto 0);
	begin
	if tlac = '0' 	then qmid := q(7 downto 0);	
						else qmid := q(15 downto 8);
		end if;

	if clk = '1' 	then qout <= qmid(3 downto 0);
						else qout <= qmid(7 downto 4);
		end if;		
end process;
-------------------------------------------------------

--ZOBRAZENI NA SEDMISEGMENTOVCE------------------------
with qout select
   segment_n	<=	"11000000" when "0000",   --0
						"11111001" when "0001",   --1
						"10100100" when "0010",   --2
						"10110000" when "0011",   --3
						"10011001" when "0100",   --4
						"10010010" when "0101",   --5
						"10000010" when "0110",   --6
						"11111000" when "0111",   --7
						"10000000" when "1000",   --8
						"10010000" when "1001",   --9
						"10001000" when others;
segment <= not segment_n;
-------------------------------------------------------

--PREPINANI KATOD--------------------------------------
process(clk)
	begin
	catode1 <= clk;
	catode2 <= not clk;
end process;
-------------------------------------------------------

end Behavioral;

